hdu5067Harry And Dig Machine(TSP旅行商问题)

题目链接:

huangjing

题意:给出一幅图,图中有一些点,然后从第1个点出发,然后途径所有有石头的点,最后回到原点,然后求最小距离。当初作比赛的时候不知道这就是旅行商经典问题。回来学了一下。

思路:

状态转移方程

DP[k][i|base[k]]=min(DP[k][i|base[k]],DP[j][i]+dis[j][k])

DP[J][I]表示从起点到j点在i状态下的最小距离。。。DP[j][i]+dis[j][k]表从j到k的距离。。。时间复杂度是(n?m+(t2)?(2t)),那么问题就得到了解决。。

题目:

Harry And Dig Machine

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 453    Accepted Submission(s): 164

Problem Description

As we all know, Harry Porter learns magic at Hogwarts School. However, learning magical knowledge alone is insufficient to become a great magician. Sometimes, Harry also has to gain knowledge from other certain subjects, such as language, mathematics, English,
and even algorithm.

Dumbledore, the headmaster of Hogwarts, is planning to construct a new teaching building in his school. The area he selects can be considered as an n*m grid, some (but no more than ten) cells of which might contain stones. We should remove the stones there
in order to save place for the teaching building. However, the stones might be useful, so we just move them to the top-left cell. Taking it into account that Harry learned how to operate dig machine in Lanxiang School several years ago, Dumbledore decides
to let him do this job and wants it done as quickly as possible. Harry needs one unit time to move his dig machine from one cell to the adjacent one. Yet skilled as he is, it takes no time for him to move stones into or out of the dig machine, which is big
enough to carry infinite stones. Given Harry and his dig machine at the top-left cell in the beginning, if he wants to optimize his work, what is the minimal time Harry needs to finish it?

Input

They are sever test cases, you should process to the end of file.

For each test case, there are two integers n and m.(1≤n,m≤50).

The next n line, each line contains m integer. The j-th number of ith line
a[i][j] means there are a[i][j] stones on the jth cell
of the ith line.( 0≤a[i][j]≤100 ,
and no more than 10 of a[i][j] will be positive integer).

Output

For each test case, just output one line that contains an integer indicate the minimal time that Harry can finish his job.

Sample Input

3 3
0 0 0
0 100 0
0 0 0
2 2
1 1
1 1

Sample Output

4
4

Source

BestCoder Round #14

Recommend

heyang   |   We have carefully selected several similar problems for you:  5069 5068 5065 5064 5061

Statistic | Submit | Discuss | Note
代码:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<map>
#include<vector>
#include<cmath>
#include<string>
#include<queue>
#define eps 1e-9
#define ll long long
#define INF 0x3f3f3f3f
using namespace std;
const int maxn=10+5;
int dp[maxn][1<<maxn],dis[maxn][maxn],base[maxn];//dp[j][i]表示在i状态下到达j的最小距离
int p[maxn][2],n,m;

int cal(int i,int j)
{
    return abs(p[i][0]-p[j][0])+abs(p[i][1]-p[j][1]);
}

int main()
{
    int cnt,k;
    while(~scanf("%d%d",&n,&m))
    {
        cnt=0;
        base[1]=1;
        for(int i=2;i<=14;i++)
            base[i]=base[i-1]<<1;
        for(int i=1;i<=n;i++)
            for(int j=1;j<=m;j++)
        {
            scanf("%d",&k);
            if(k||(i==1&&j==1))
            {
                p[++cnt][0]=i;
                p[cnt][1]=j;
            }
        }
        memset(dis,0,sizeof(dis));
        for(int i=1;i<=cnt;i++)
            for(int j=i+1;j<=cnt;j++)
                    dis[i][j]=dis[j][i]=cal(i,j);
        memset(dp,INF,sizeof(dp));
        dp[1][0]=0;
        int lim=1<<cnt;
        for(int i=0;i<lim;i++)//状态
            for(int j=1;j<=cnt;j++)//j点为起点
            {
                if(dp[j][i]==INF)  continue;
                for(int k=1;k<=cnt;k++)//转移到的点
                {
                    if(i&base[k])  continue;
                    dp[k][i|base[k]]=min(dp[k][i|base[k]],dp[j][i]+dis[j][k]);
                }
            }
        printf("%d\n",dp[1][lim-1]);
    }
    return 0;
}
时间: 2024-08-25 01:09:36

hdu5067Harry And Dig Machine(TSP旅行商问题)的相关文章

BestCoder Round #14 B 题 Harry And Dig Machine 【TSP】

题目:Harry And Dig Machine 哈哈  终于涨边粉色了,不容易呀.顺便写一道题解吧 题意:给一个m*n的矩阵,然后其中最多由10个有值,求总左上角把所有的值都拿上回到左上角的最小步数. 标准的TSP回到原点问题,需要先预处理出图来,然后TSP即可. AC代码: #include <cstdio> #include <algorithm> #include <cstring> #include <string> #include <io

BestCoder Round #14 B 称号 Harry And Dig Machine 【TSP】

称号:Harry And Dig Machine 哈哈  最终涨边粉色了,不easy呀.顺便写一道题解吧 题意:给一个m*n的矩阵,然后当中最多由10个有值,求总左上角把全部的值都拿上回到左上角的最小步数. 标准的TSP回到原点问题,须要先预处理出图来.然后TSP就可以. AC代码: #include <cstdio> #include <algorithm> #include <cstring> #include <string> #include <

HDU 5067 Harry And Dig Machine(状压DP)(TSP问题)

题目地址:pid=5067">HDU 5067 经典的TSP旅行商问题模型. 状压DP. 先分别预处理出来每两个石子堆的距离.然后将题目转化成10个城市每一个城市至少经过一次的最短时间模型.然后简单的状压DP就可以. 代码例如以下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #incl

HDU 5067 Harry And Dig Machine

Harry And Dig Machine Time Limit: 1000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 506764-bit integer IO format: %I64d      Java class name: Main As we all know, Harry Porter learns magic at Hogwarts School. However, lear

hdu 5067 Harry And Dig Machine (状态压缩dp)

题目链接 bc上的一道题,刚开始想用这个方法做的,因为刚刚做了一个类似的题,但是想到这只是bc的第二题, 以为用bfs水一下就过去了,结果MLE了,因为bfs的队列里的状态太多了,耗内存太厉害. 题意: 从某一点出发,遍历网格上的一些点,每个点至少访问一次需要的最小时间是多少. 官方题解: 由于Harry的dig machine是无限大的,而装载石头和卸载石头是不费时间的,所以问题可以转化成:从某一点出发,遍历网格上的一些点,每个点至少访问一次需要的最小时间是多少.这就是经典的旅行商问题,考虑到

HDU 5067 Harry And Dig Machine(状压dp)

HDU 5067 Harry And Dig Machine 思路:由于点才10个,在加上一个起点,处理出每个点之间的曼哈顿距离,然后用状压dp搞,状态表示为: dp[i][s],表示在i位置,走过的点集合为s的最小代价 代码: #include <cstdio> #include <cstring> #include <cstdlib> #include <algorithm> using namespace std; const int N = 15;

HDOJ 5067 Harry And Dig Machine 状压DP

状压DP....dp[i][j]已经走过的点的状态,目前再j点的最小距离 Harry And Dig Machine Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 560    Accepted Submission(s): 210 Problem Description As we all know, Harry Porter le

hdu 5067 Harry And Dig Machine(BestCoder Round #14)

Harry And Dig Machine Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 332    Accepted Submission(s): 104 Problem Description As we all know, Harry Porter learns magic at Hogwarts School. Howeve

HDU 5067-Harry And Dig Machine(DFS)

Harry And Dig Machine Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 435    Accepted Submission(s): 153 Problem Description As we all know, Harry Porter learns magic at Hogwarts School. Howeve